Attribute VB_Name = "mdlShutDown"
Public Declare Function GetCurrentProcess Lib "kernel32" () As Long
Public Declare Function AdjustTokenPrivileges Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Public Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Public Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Public Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Public Enum EWX
ewxFORCE = 4&
ewxLOGOFF = 0&
ewxREBOOT = 2&
ewxSHUTDOWN = 1&
End Enum

Public Type LUID
    LowPart As Long
    HighPart As Long
End Type
Private Type LUID_AND_ATTRIBUTES
        pLuid As LUID
        Attributes As Long
End Type
Public Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(1) As LUID_AND_ATTRIBUTES
End Type
Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type

Public Sub ShutDown(ByVal Flags As EWX)
Dim hToken As Long
Dim lpLuid As LUID
Dim nState As TOKEN_PRIVILEGES
Dim pState As TOKEN_PRIVILEGES
Dim osVer As OSVERSIONINFO
osVer.dwOSVersionInfoSize = Len(osVer)
GetVersionEx osVer
If osVer.dwPlatformId = 2 Then
If OpenProcessToken(GetCurrentProcess, &H28, hToken) = 0 Then Exit Sub
If LookupPrivilegeValue("", "SeShutdownPrivilege", lpLuid) = 0 Then Exit Sub
With nState
.PrivilegeCount = 1
.Privileges(0).Attributes = 2
.Privileges(0).pLuid = lpLuid
End With
If AdjustTokenPrivileges(hToken, 0, nState, Len(nState), pState, Len(pState)) = 0 Then Exit Sub
End If
ExitWindowsEx Flags, 0
End Sub
